/***********************************************************************/
/* QUERY.H -                                                           */
/* This file contains defines   related to QUERY,STATUS and EXTRACT    */
/***********************************************************************/
/*
 * THE - The Hessling Editor. A text editor similar to VM/CMS xedit.
 * Copyright (C) 1991-1997 Mark Hessling
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to:
 *
 *    The Free Software Foundation, Inc.
 *    675 Mass Ave,
 *    Cambridge, MA 02139 USA.
 *
 *
 * If you make modifications to this software that you feel increases
 * it usefulness for the rest of the community, please email the
 * changes, enhancements, bug fixes as well as any and all ideas to me.
 * This software is going to be maintained and enhanced as deemed
 * necessary by the community.
 *
 * Mark Hessling                 Email:             M.Hessling@qut.edu.au
 * PO Box 203                    Phone:                    +617 3802 0800
 * Bellara                       http://www.gu.edu.au/gext/the/markh.html
 * QLD 4507                      **** Maintainer PDCurses & REXX/SQL ****
 * Australia                     ************* Author of THE ************
 */

/*
$Id: query.h 2.1 1995/06/24 16:30:57 MH Rel MH $
*/


/*---------------------------------------------------------------------*/
/* The order of these items determine the order they appear as a result*/
/* of the STATUS command, so they should be in alphabetical order.     */
/*---------------------------------------------------------------------*/
/* The following are item number defines for EXTRACT/QUERY/STATUS.     */
/*---------------------------------------------------------------------*/
#define ITEM_ALT                              0
#define ITEM_ARBCHAR                          1
#define ITEM_AUTOSAVE                         2
#define ITEM_BACKUP                           3
#define ITEM_BEEP                             4
#define ITEM_BLOCK                            5
#define ITEM_CASE                             6
#define ITEM_CLEARSCREEN                      7
#define ITEM_CLOCK                            8
#define ITEM_CMDARROWS                        9
#define ITEM_CMDLINE                         10
#define ITEM_COLOR                           11
#define ITEM_COLOUR                          12
#define ITEM_COLUMN                          13
#define ITEM_COMPAT                          14
#define ITEM_CURLINE                         15
#define ITEM_CURSOR                          16
#define ITEM_CURSORSTAY                      17
#define ITEM_DEFSORT                         18
#define ITEM_DIRFILEID                       19
#define ITEM_DISPLAY                         20
#define ITEM_EOF                             21
#define ITEM_EOLOUT                          22
#define ITEM_ETMODE                          23
#define ITEM_FEXT                            24
#define ITEM_FIELD                           25
#define ITEM_FILENAME                        26
#define ITEM_FMODE                           27
#define ITEM_FNAME                           28
#define ITEM_FPATH                           29
#define ITEM_FTYPE                           30
#define ITEM_FULLFNAME                       31
#define ITEM_GETENV                          32
#define ITEM_HEX                             33
#define ITEM_HEXDISPLAY                      34
#define ITEM_HEXSHOW                         35
#define ITEM_HIGHLIGHT                       36
#define ITEM_IDLINE                          37
#define ITEM_IMPMACRO                        38
#define ITEM_IMPOS                           39
#define ITEM_INPUTMODE                       40
#define ITEM_INSERTMODE                      41
#define ITEM_LASTMSG                         42
#define ITEM_LASTRC                          43
#define ITEM_LENGTH                          44
#define ITEM_LINE                            45
#define ITEM_LINEFLAG                        46
#define ITEM_LINEND                          47
#define ITEM_LSCREEN                         48
#define ITEM_MACRO                           49
#define ITEM_MACROEXT                        50
#define ITEM_MACROPATH                       51
#define ITEM_MARGINS                         52
#define ITEM_MONITOR                         53
#define ITEM_MOUSE                           54
#define ITEM_MSGLINE                         55
#define ITEM_MSGMODE                         56
#define ITEM_NBFILE                          57
#define ITEM_NEWLINES                        58
#define ITEM_NONDISP                         59
#define ITEM_NUMBER                          60
#define ITEM_PENDING                         61
#define ITEM_POINT                           62
#define ITEM_POSITION                        63
#define ITEM_PREFIX                          64
#define ITEM_PRINTER                         65
#define ITEM_READV                           66
#define ITEM_REPROFILE                       67
#define ITEM_RESERVED                        68
#define ITEM_REXXOUTPUT                      69
#define ITEM_RING                            70
#define ITEM_SCALE                           71
#define ITEM_SCOPE                           72
#define ITEM_SCREEN                          73
#define ITEM_SELECT                          74
#define ITEM_SHADOW                          75
#define ITEM_SHOWKEY                         76
#define ITEM_SIZE                            77
#define ITEM_STATUSLINE                      78
#define ITEM_STAY                            79
#define ITEM_TABKEY                          80
#define ITEM_TABLINE                         81
#define ITEM_TABS                            82
#define ITEM_TABSIN                          83
#define ITEM_TABSOUT                         84
#define ITEM_TERMINAL                        85
#define ITEM_TOF                             86
#define ITEM_TYPEAHEAD                       87
#define ITEM_UNDOING                         88
#define ITEM_UNTAA                           89
#define ITEM_VERIFY                          90
#define ITEM_VERSHIFT                        91
#define ITEM_VERSION                         92
#define ITEM_WIDTH                           93
#define ITEM_WORD                            94
#define ITEM_WORDWRAP                        95
#define ITEM_WRAP                            96
#define ITEM_XTERMINAL                       97
#define ITEM_ZONE                            98
/*---------------------------------------------------------------------*/
/* The following are item number defines for the boolean functions.    */
/*---------------------------------------------------------------------*/
#define ITEM_START_BOOLEANS                 200
#define ITEM_AFTER_FUNCTION                 200
#define ITEM_BATCH_FUNCTION                 201
#define ITEM_BEFORE_FUNCTION                202
#define ITEM_BLANK_FUNCTION                 203
#define ITEM_BLOCK_FUNCTION                 204
#define ITEM_BOTTOMEDGE_FUNCTION            205
#define ITEM_COMMAND_FUNCTION               206
#define ITEM_CURRENT_FUNCTION               207
#define ITEM_DIR_FUNCTION                   208
#define ITEM_END_FUNCTION                   209
#define ITEM_EOF_FUNCTION                   210
#define ITEM_FIRST_FUNCTION                 211
#define ITEM_FOCUSEOF_FUNCTION              212
#define ITEM_FOCUSTOF_FUNCTION              213
#define ITEM_INBLOCK_FUNCTION               214
#define ITEM_INCOMMAND_FUNCTION             215
#define ITEM_INITIAL_FUNCTION               216
#define ITEM_INPREFIX_FUNCTION              217
#define ITEM_LEFTEDGE_FUNCTION              218
#define ITEM_MODIFIABLE_FUNCTION            219
#define ITEM_MULTWINDOW_FUNCTION            220
#define ITEM_RIGHTEDGE_FUNCTION             221
#define ITEM_SHADOW_FUNCTION                222
#define ITEM_SPACECHAR_FUNCTION             223
#define ITEM_TOF_FUNCTION                   224
#define ITEM_TOPEDGE_FUNCTION               225
#define ITEM_VERONE_FUNCTION                226
/*---------------------------------------------------------------------*/
/* The following are item number defines for the 'other' functions.    */
/*---------------------------------------------------------------------*/
#define ITEM_VALID_TARGET_FUNCTION          250
#define ITEM_RUN_OS_FUNCTION                251

#define MAX_VARIABLES_RETURNED               30
