#
#########################################################################
#
# makefile for The Hessling Editor (THE)
#
#########################################################################
#

VER = 25
PROJ = proj   # this will get replaced by uncommenting a section
MAN  = man    # this will get replaced by uncommenting a section

#########################################################################
# Watcom  compiler on OS/2
#########################################################################
!ifeq %COMPUTERNAME SNARK
SRC       = c:\the\
WATCOMSRC = c:\watcom\src\startup\
CURSLIB   = c:\pdc\4s\pdcurses.lib
CURSINC   = /i=c:\curses #/i=e:\mhes\watcom\h
REXXINC   = /i=e:\regina-0.08f /DUSE_REGINA
REXXLIB   = e:\regina-0.08f\4s\rexx.lib
!else
SRC       = e:\mhes\the\
WATCOMSRC = e:\mhes\watcom\src\startup\
CURSLIB   = e:\mhes\pdc\4s\pdcurses.lib
CURSINC   = /i=e:\mhes\curses /i=e:\mhes\watcom\h
REXXINC   = /i=e:\mhes\regina-0.08e /DUSE_REGINA
REXXLIB   = e:\mhes\regina\vc\reginaw.lib
!endif

PROJ      = the.exe
OBJ       = obj
CC        = wcc386


!ifeq DEBUG CODEVIEW
CFLAGS    = /zz /d3 /hc /od /4s /ei /zp4 /zq /mf /DSTDC_HEADERS /DPROTO /DWIN32 /i=$(SRC) $(CURSINC) $(REXXINC) /fo=$@
LDEBUG     = debug codeview
!else
!ifeq DEBUG WATCOM
CFLAGS    = /zz /d2 /4s /ei /zp4 /zq /mf /DSTDC_HEADERS /DPROTO /DWIN32 /i=$(SRC) $(CURSINC) $(REXXINC) /fo=$@
LDEBUG     = debug watcom all
!else
CFLAGS    = /oneatx /zz /4s /ei /zp4 /zq /mf /DSTDC_HEADERS /DPROTO /DWIN32 /i=$(SRC) $(CURSINC) $(REXXINC) /fo=$@
LDEBUG     =
!endif
!endif
LD        = wlink
XTRAOBJ   = getopt.obj
MAN       = manext.exe
MANLD     = link386 manext+getopt+wildargv,,,,ibm-man.def /NOE /NOI /EXEPACK /ALIGN:4;
RCTHE     = echo the
#RCTHE     = rc $(SRC)\the.res $(PROJ)
docdir = doc
#########################################################################
#
#
# Object files
#
OBJ1 = box.$(OBJ) colour.$(OBJ) comm1.$(OBJ) comm2.$(OBJ) comm3.$(OBJ) comm4.$(OBJ) comm5.$(OBJ) &
	commset1.$(OBJ) commset2.$(OBJ) commsos.$(OBJ) cursor.$(OBJ) default.$(OBJ) &
	edit.$(OBJ) error.$(OBJ) execute.$(OBJ) linked.$(OBJ) column.obj mouse.obj memory.obj &
	nonansi.$(OBJ) prefix.$(OBJ) reserved.$(OBJ) scroll.$(OBJ) show.$(OBJ) sort.$(OBJ) &
	target.$(OBJ) the.$(OBJ) util.$(OBJ)
OBJ2 = commutil.$(OBJ) #trace.obj
OBJ3 = getch.$(OBJ)
OBJ4 = query.$(OBJ)
OBJ5 = fnmatch.$(OBJ)
OBJ6 = directry.$(OBJ) file.$(OBJ)
OBJ7 = rexx.$(OBJ)
OBJ8 = wildargv.obj
OBJX = $(XTRAOBJ)
OBJS = $(OBJ1) $(OBJ2) $(OBJ3) $(OBJ4) $(OBJ5) $(OBJ6) $(OBJ7) $(OBJ8) $(OBJX)
#########################################################################

COMM = $(SRC)comm1.c $(SRC)comm2.c $(SRC)comm3.c $(SRC)comm4.c $(SRC)comm5.c &
	$(SRC)commsos.c $(SRC)commset1.c $(SRC)commset2.c $(SRC)query.c

APPENDIX = $(SRC)appendix.1
GLOSSARY = $(SRC)glossary

#
#########################################################################
$(PROJ):	$(OBJS)
	echo option quiet         >  the.lnk
	echo option map           >> the.lnk
	echo system nt            >> the.lnk
	echo alias _RexxStart=RexxStart >> the.lnk
	echo alias _RexxVariablePool=RexxVariablePool >> the.lnk
	echo alias _RexxRegisterSubcomExe=RexxRegisterSubcomExe >> the.lnk
	echo alias _RexxRegisterExitExe=RexxRegisterExitExe >> the.lnk
	echo alias _RexxRegisterFunctionExe=RexxRegisterFunctionExe >> the.lnk
	echo alias _RexxDeregisterSubcom=RexxDeregisterSubcom >> the.lnk
	echo alias _RexxDeregisterExit=RexxDeregisterExit >> the.lnk
	echo alias _RexxDeregisterFunction=RexxDeregisterFunction >> the.lnk
	echo name the.exe         >> the.lnk
	echo file *.obj           >> the.lnk
	echo library $(CURSLIB)   >> the.lnk
	echo library $(REXXLIB)   >> the.lnk
	$(LD) $(LDEBUG) $(LDFLAGS) @the.lnk
	$(RCTHE)
	del the.lnk
#########################################################################
box.obj:	$(SRC)box.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
colour.obj:	$(SRC)colour.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
comm1.obj:	$(SRC)comm1.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
comm2.obj:	$(SRC)comm2.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
comm3.obj:	$(SRC)comm3.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
comm4.obj:	$(SRC)comm4.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
comm5.obj:	$(SRC)comm5.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
commset1.obj:	$(SRC)commset1.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
commset2.obj:	$(SRC)commset2.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
commsos.obj:	$(SRC)commsos.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
cursor.obj:	$(SRC)cursor.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
default.obj:	$(SRC)default.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
edit.obj:	$(SRC)edit.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
error.obj:	$(SRC)error.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
execute.obj:	$(SRC)execute.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
linked.obj:	$(SRC)linked.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
column.obj:	$(SRC)column.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
mouse.obj:	$(SRC)mouse.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
memory.obj:	$(SRC)memory.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
nonansi.obj:	$(SRC)nonansi.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
prefix.obj:	$(SRC)prefix.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
reserved.obj:	$(SRC)reserved.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
scroll.obj:	$(SRC)scroll.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
show.obj:	$(SRC)show.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
sort.obj:	$(SRC)sort.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
target.obj:	$(SRC)target.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
the.obj:	$(SRC)the.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
util.obj:	$(SRC)util.c $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
commutil.obj:	$(SRC)commutil.c $(SRC)the.h $(SRC)command.h $(SRC)defines.h $(SRC)proto.h $(SRC)getch.h $(SRC)key.h
	$(CC) $(CFLAGS) $(SRC)$*.c
trace.obj:	$(SRC)trace.c $(SRC)the.h $(SRC)command.h $(SRC)defines.h $(SRC)proto.h $(SRC)getch.h $(SRC)key.h
	$(CC) $(CFLAGS) $(SRC)$*.c
getch.obj:	$(SRC)getch.c $(SRC)getch.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
query.obj:	$(SRC)query.c $(SRC)query.h $(SRC)the.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
fnmatch.obj:	$(SRC)fnmatch.c $(SRC)the.h $(SRC)fnmatch.h
	$(CC) $(CFLAGS) $(SRC)$*.c
directry.obj:	$(SRC)directry.c $(SRC)the.h $(SRC)directry.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
file.obj:	$(SRC)file.c $(SRC)the.h $(SRC)directry.h $(SRC)defines.h $(SRC)proto.h
	$(CC) $(CFLAGS) $(SRC)$*.c
rexx.obj:	$(SRC)rexx.c $(SRC)the.h $(SRC)therexx.h $(SRC)proto.h $(SRC)defines.h $(SRC)query.h
	$(CC) $(CFLAGS) $(SRC)$*.c
getopt.obj:	$(SRC)getopt.c
	$(CC) $(CFLAGS) $(SRC)$*.c

wildargv.obj:	$(WATCOMSRC)wildargv.c
	$(CC) $(CFLAGS) $(WATCOMSRC)$*.c
#
#########################################################################
manual:	$(MAN) $(SRC)overview $(COMM) $(APPENDIX) $(GLOSSARY)
	manext $(SRC)overview $(COMM) $(APPENDIX) $(GLOSSARY) > the.man
#
$(MAN):	$(XTRAOBJ) manext.$(OBJ)
	$(MANLD)
	$(CHMODMAN)


zip:
	zip thesrc$(VER) README INSTALL TODO COPYING HISTORY THE_Help.txt
	zip thesrc$(VER) overview appendix.1 appendix.2 appendix.3 glossary README.OS2
	zip thesrc$(VER) box.c colour.c comm*.c cursor.c default.c directry.c
	zip thesrc$(VER) edit.c error.c norexx.c scroll.c column.c execute.c
	zip thesrc$(VER) file.c fnmatch.c getch.c getopt.c linked.c mouse.c memory.c
	zip thesrc$(VER) nonansi.c os2eas.c prefix.c query.c reserved.c
	zip thesrc$(VER) rexx.c show.c sort.c target.c the.c trace.c util.c
	zip thesrc$(VER) command.h defines.h directry.h fnmatch.h getch.h
	zip thesrc$(VER) key.h query.h proto.h rexxfill.h therexx.h the.h makefile.dist $(docdir)/*.gif
	zip thesrc$(VER) manext.c *.rsp *.def *.diz files.rcs the*.xbm icons.zip the.res the.rc the.eas
	zip thesrc$(VER) append.the comm.the uncomm.the total.the match.the rm.the
	zip thesrc$(VER) words.the l.the compile.the spell.the demo.the demo.txt
	zip thesrc$(VER) Makefile.in configure config.h.in $(docdir)/THE_Help*
	zip thesrc$(VER) config.guess config.sub install-sh
	zip thesrc$(VER) aclocal.m4 configure.in
	zip thesrc$(VER) man2html.rex
#
